/* Mereni teploty a vlhkosti s cidlem AM2302 (DHT22)
 * se zobrazovanim hodnot na monitoru PC 
*/
#include <DHT.h>             // pripojeni knihovny pro mereni s cidlem AM2302, (DHT22)
#include "DHT.h"             // pripojeni potrebne knihovny
#define pinDHT 3             // nastaveni cisla pinu pro snimani dat z cidla
DHT dht(pinDHT, DHT22);      // vytvoreni instance senzoru z knihovny,
                             // s nastavenim typu DHT22, ktery ma stejny
                             // typ komunikace jako AM2102
void setup() {
Serial.begin(9600);          // inicializace komunikace po seriove lince
dht.begin();                 // zahajeni komunikace se senzorem DHT         
}

void loop() {
 float teplota = dht.readTemperature();             // nacteni teploty do promenne
 float vlhkost = dht.readHumidity();                // nacteni vlhkosti do promenne
 if (isnan(teplota) || isnan(vlhkost)) {            // kontrola, jestli jsou nactene hodnoty cisla, pomoci funkce isnan
 Serial.println("Chyba pri cteni z DHT senzoru!");  // pri chybnem cteni vypis hlsky
  } else {
  Serial.print("Teplota: ");                        // pokud jsou hodnoty v poradku, vypis je po seriove lince
  Serial.print(teplota);                            // vypis na monitoru PC nactene teploty z cidla
  Serial.print(" st Celsia, ");                     // vypis na monitoru PC o jakou hodnotu jde 
  Serial.print("vlhkost: ");                        // vypis na monitoru PC dalsi hodnoty
  Serial.print(vlhkost);                            // vypis na monitoru PC nactene vlhkosti z cidla
  Serial.println("% RH.");                          // vypis na monitoru PC o jakou hodnotu jde
  }                                                 // konec smycky else   
  delay(2000);                                      // pauza pred novym behem smycky
}                                                   // konec hlavni smycky loop
