/* Mereni teploty a vlhkosti s cidlem AM2302 (DHT22)zobrazeni 
 * na LCD displeji SIC1602A20 2x16 znaku se seriovym radicem
 * 26.11.2022 vagnervlastimil@seznam.cz
 */
//===============================================================================================
#include <SoftwareSerial.h>    // pripojeni knihovny pro LCD displej
#include <DHT.h>               // pripojeni knihovny pro cidlo
#include "DHT.h"               // pripojeni potrebne knihovny
#define txPin 2                // definovani komunikacniho pinu s lcd displejem klidova uroven na lcd je nastavena na "T" vysoka 
#define pinDHT 3               // nastaveni cisla pinu pro snimani dat z cidla
DHT dht(pinDHT, DHT22);        // vytvoreni instalace senzoru z knihovny
const int LCDdelay=200;        // nastaveni casove prodlevy pro lcd displej
SoftwareSerial LCD = SoftwareSerial(0, txPin); // pripojeni nastavenych parametru ke knihovne

void setup() {                 // setup nastaveni parametru 
pinMode(txPin, OUTPUT);        // nastaveni komunikacniho pinu na vystup
LCD.begin(2400);               // nastavena komunikacni rychlost pro komunikaci s lcd displejem
dht.begin();                   // zahajeni komunikace se senzorem DHT         
smazLCD();                     // prikaz pro inicializaci lcd a smazani displeje
podsviceniOn() ;               // zapnuti podsviceni displeje
kursorOff();                   // vypnuti kursoru blikani
posunvpravo();                 // nastaveni posunu znaku vpravo  
}                              // konec prikazu v setupu

void loop() {                                        // zacatek hlavni smycky programu
float teplota = dht.readTemperature();               // nacteni teploty do promenne
 float vlhkost = dht.readHumidity();                 // nacteni vlhkosti do promenne
 if (isnan(teplota) || isnan(vlhkost)) {             // kontrola, jestli jsou nactene hodnoty cisla, pomoci funkce isnan
 smazLCD();                                          // prikaz pro inicializaci lcd a smazani displeje
 LCDpoziceznaku(0,0); LCD.print("Chyba komunikace"); // nastaveni pozice prvniho znaku na prvnim radku vypis hlasky
  } else {
 LCDpoziceznaku(0,0); LCD.print("Teplota:");         // nastaveni pozice prvniho znaku na prvnim radku
 LCD.print(teplota);                                 // vypis nactene teploty z cidla
 LCD.print("stC");                                   // vypis na lcd o jakou hodnotu jde 
 LCDpoziceznaku(1,0); LCD.print("Vlhkost:");         // nastaveni pozice prvniho znaku na druhem radku
 LCD.print(vlhkost);                                 // vypis nactene hodnoty z cidla   
 LCD.print("%RH");                                   // vypis na lcd o jakou hodnotu jde
  }                                                  // konec smycky else   
  delay(2000);                                       // pauza pred novym behem smycky
}                                                    // knec hlavni smycky loop

//podprogramy pro nastaveni lcd displeje mozno doplnit o dalsi prikazy z dokumentace k LCD

void LCDpoziceznaku(int row, int col){                 // nastaveni pozice zobrazeni znaku
 LCD.write(0xFE); LCD.write((col + row*64 + 128));}    // vypocet pozice znaku
void smazLCD(){                                        // smazani a inicializace lcd displeje
 LCD.write(0xFE); LCD.write(0x01); delay(LCDdelay);}   // prikaz pro smazani
void podsviceniOn(){                                   // zapnuti podsviceni lcd displeje 
 LCD.write(0xFE); LCD.write(0xE9);  delay(LCDdelay);}  // prikaz pro zapnuti
void podsviceniOff(){                                  // vypnuti podsviceni lcd displeje
 LCD.write(0xFE); LCD.write(0xE8);  delay(LCDdelay);}  // prikaz pro vypnuti podsviceni displeje
void kursorOn(){                                       // zapnuti kursoru podtrzitka blikani
LCD.write(0xFE); LCD.write(0x0E); delay(LCDdelay);}    // prikaz pro zapnuti kursoru zobrazeni
void kursorOff(){                                      // prikaz pro vypnuti zobrazeni kursoru
LCD.write(0xFE); LCD.write(0x0C); delay(LCDdelay);}    // prikaz pro vypnuti kursoru
void posunvpravo(){                                    // zapsane znaky se zapisuji zleva doprava
LCD.write(0xFE); LCD.write(0x06); delay(LCDdelay);}    // prikaz pro posun zapsanych znaku
